#include <iostream>
#define int long long
using namespace std;
int v[1000005];
int32_t main()
{
    int n,k;
    cin>>n>>k;
    int cnt=0;
    int cnt2=0;
    for(int i=1;i<=n;i++){
        cin>>v[i];
        if(v[i]==1) cnt++;
        if(v[i]==2) cnt2++;
    }
    if(cnt2>=k){
        int nr=0;
        int secv=0;
        int doi=0;
        for(int i=1;i<=n;i++){
            if(v[i]==1){
                if(doi==1) secv++,nr=0,doi=0;
                else nr++;
            }
            if(v[i]==2){
                if(nr>0) secv++,nr=0,doi=0;
                else doi=1;
            }
        }
        if(secv>=k) cout<<3;
        else cout<<2;
    }
    else if(cnt>=k) cout<<1;
    else cout<<0;
    return 0;
}
